public class EquationDegre2 {
	// coefficients équation ax^2+bx+c=0
	private double a;
	private double b;
	private double c;
	
	// racines de l'équation
	private double x1;
	private double x2;

	// nombre de racines, -1 si l'équation n'est pas résolue
	private int nombreRacines = -1;

	public EquationDegre2(double a, double b, double c) throws DegeneratedEquationDegre2Exception {
		if (a == 0) throw new DegeneratedEquationDegre2Exception();
		this.a = a;
		this.b = b;
		this.c = c;
	}

	public void resolve() {
		// a cannot be null or object cannot be constructed
		double delta = b * b - 4 * a * c;
		if (delta < 0){
			nombreRacines = 0;
		} else if (delta == 0){
			nombreRacines = 1;
			x1 = - b / ( 2 * a );
		} else {
			nombreRacines = 2;
			x1 = (- b - Math.sqrt(delta)) / ( 2 * a );
			x2 = (- b + Math.sqrt(delta)) / ( 2 * a );
		}
	}

	public double getNombreRacines() throws UnresolvedException {
		if (nombreRacines == -1) throw new UnresolvedException() ;
		return nombreRacines;
	}

	public double getX1() throws UnresolvedException, InvalidRootException {
		if (nombreRacines == -1) throw new UnresolvedException() ;
		if (nombreRacines < 1) throw new InvalidRootException("X1");
		return x1;
	}

	public double getX2() throws UnresolvedException, InvalidRootException {
		if (nombreRacines == -1) throw new UnresolvedException() ;
		if (nombreRacines < 2) throw new InvalidRootException("X2") ;
		return x2;
	}
}
